﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.Misc;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            // show the event alerts
            for (int i = 0; i < this.checkedListBox1.CheckedItems.Count; i++)
            {
                // show the alert
                // if an alert is currently shown, put the alert into a queue that is checked 
                // when the UltraDeskTopAlert closes
                this.ShowAlert(this.checkedListBox1.CheckedItems[i] as string);
            }
        }

        List<string> alertQueue = new List<string>();
        string alertKey = "ALERTKEY";

        private void ShowAlert(string alertString)
        {
            // if the UltraDesktopAlert is open, queue the new alert
            if (this.ultraDesktopAlert1.IsOpen(this.alertKey))
            {
                this.alertQueue.Add(alertString);
                return;
            }

            // show the new alert
            UltraDesktopAlertShowWindowInfo windowInfo = new UltraDesktopAlertShowWindowInfo(alertString, alertString);
            windowInfo.Key = this.alertKey;
            this.ultraDesktopAlert1.Show(windowInfo);
        }
        private void ultraDesktopAlert1_DesktopAlertClosed(object sender, DesktopAlertClosedEventArgs e)
        {
            // if any alerts are queued, take the first one off the queue and display it.
            if (this.alertQueue.Count > 0)
            {
                string alertString = this.alertQueue[0];
                this.alertQueue.RemoveAt(0);
                this.BeginInvoke((Action)delegate()
                {
                    this.ShowAlert(alertString);
                });
            }
        }

    }
}
